#define MATRIXC

#include "matrix.h"

/*
#define DEBUG_MATRIXC_0
*/

void Matrix_4x4_Multiplication(double **A, double **B, double **C)
{
   double D[4][4];
   double B_Col_0[4];
   double B_Col_1[4];
   double B_Col_2[4];
   double B_Col_3[4];
   int    i;

   for (i = 0; i < 4; i++)
   {
      B_Col_0[i] = B[i][0];
      B_Col_1[i] = B[i][1];
      B_Col_2[i] = B[i][2];
      B_Col_3[i] = B[i][3];
#if 0
      printf("B_Col_0[%d] = %g\n", i, B_Col_0[i]);
      printf("B_Col_1[%d] = %g\n", i, B_Col_1[i]);
      printf("B_Col_2[%d] = %g\n", i, B_Col_2[i]);
      printf("B_Col_3[%d] = %g\n", i, B_Col_3[i]);
#endif
   }


   D[0][0] = A[0][0] * B_Col_0[0] + A[0][1] * B_Col_1[0] + A[0][2] * B_Col_2[0]
             + A[0][3] * B_Col_3[0];

   D[0][1] = A[0][0] * B_Col_0[1] + A[0][1] * B_Col_1[1] + A[0][2] * B_Col_2[1]
             + A[0][3] * B_Col_3[1];

   D[0][2] = A[0][0] * B_Col_0[2] + A[0][1] * B_Col_1[2] + A[0][2] * B_Col_2[2]
             + A[0][3] * B_Col_3[2];

   D[0][3] = A[0][0] * B_Col_0[3] + A[0][1] * B_Col_1[3] + A[0][2] * B_Col_2[3]
             + A[0][3] * B_Col_3[3];

   D[1][0] = A[1][0] * B_Col_0[0] + A[1][1] * B_Col_1[0] + A[1][2] * B_Col_2[0]
             + A[1][3] * B_Col_3[0];

   D[1][1] = A[1][0] * B_Col_0[1] + A[1][1] * B_Col_1[1] + A[1][2] * B_Col_2[1]
             + A[1][3] * B_Col_3[1];

   D[1][2] = A[1][0] * B_Col_0[2] + A[1][1] * B_Col_1[2] + A[1][2] * B_Col_2[2]
             + A[1][3] * B_Col_3[2];

   D[1][3] = A[1][0] * B_Col_0[3] + A[1][1] * B_Col_1[3] + A[1][2] * B_Col_2[3]
             + A[1][3] * B_Col_3[3];

   D[2][0] = A[2][0] * B_Col_0[0] + A[2][1] * B_Col_1[0] + A[2][2] * B_Col_2[0]
             + A[2][3] * B_Col_3[0];

   D[2][1] = A[2][0] * B_Col_0[1] + A[2][1] * B_Col_1[1] + A[2][2] * B_Col_2[1]
             + A[2][3] * B_Col_3[1];

   D[2][2] = A[2][0] * B_Col_0[2] + A[2][1] * B_Col_1[2] + A[2][2] * B_Col_2[2]
             + A[2][3] * B_Col_3[2];

   D[2][3] = A[2][0] * B_Col_0[3] + A[2][1] * B_Col_1[3] + A[2][2] * B_Col_2[3]
             + A[2][3] * B_Col_3[3];

   D[3][0] = A[3][0] * B_Col_0[0] + A[3][1] * B_Col_1[0] + A[3][2] * B_Col_2[0]
             + A[3][3] * B_Col_3[0];

   D[3][1] = A[3][0] * B_Col_0[1] + A[3][1] * B_Col_1[1] + A[3][2] * B_Col_2[1]
             + A[3][3] * B_Col_3[1];

   D[3][2] = A[3][0] * B_Col_0[2] + A[3][1] * B_Col_1[2] + A[3][2] * B_Col_2[2]
             + A[3][3] * B_Col_3[2];

   D[3][3] = A[3][0] * B_Col_0[3] + A[3][1] * B_Col_1[3] + A[3][2] * B_Col_2[3]
             + A[3][3] * B_Col_3[3];

   COPY_MATRIX(C, D);
}

void Vector_Matrix_Multiplication(Vector, A, Result_Vector)
double Vector[3];
double A[4][4];
double Result_Vector[3];
{
   double Homo_Coor;

   Homo_Coor = Vector[I_HAT] * A[0] [3] + Vector[J_HAT] * A[1] [3]
               + Vector[K_HAT] * A[2] [3] + A[3] [3];
   
   Result_Vector[I_HAT] = (Vector[I_HAT] * A[0] [0] + Vector[J_HAT] * A[1] [0]
                          + Vector[K_HAT] * A[2] [0] + A[3] [0]) / Homo_Coor;

   Result_Vector[J_HAT] = (Vector[I_HAT] * A[0] [1] + Vector[J_HAT] * A[1] [1]
                          + Vector[K_HAT] * A[2] [1] + A[3] [1]) / Homo_Coor;

   Result_Vector[K_HAT] = (Vector[I_HAT] * A[0] [2] + Vector[J_HAT] * A[1] [2]
                          + Vector[K_HAT] * A[2] [2] + A[3] [2]) / Homo_Coor;
}

#ifdef DEBUG_MATRIXC_0
main()
{
   double A[4] [4];
   double B[4] [4];
   double C[4] [4];
   double Vector1[3];
   double Vector2[3];
   int   i;

   A[0] [0] = 1.0;
   A[0] [1] = 0.0;
   A[0] [2] = 0.0;
   A[0] [3] = 0.0;

   A[1] [0] = 0.0;
   A[1] [1] = 1.0;
   A[1] [2] = 0.0;
   A[1] [3] = 0.0;

   A[2] [0] = 0.0;
   A[2] [1] = 0.0;
   A[2] [2] = 1.0;
   A[2] [3] = 0.0;

   A[3] [0] = 0.0;
   A[3] [1] = 0.0;
   A[3] [2] = 0.0;
   A[3] [3] = 1.0;

   B[0] [0] = 1.0;
   B[0] [1] = 1.0;
   B[0] [2] = 1.0;
   B[0] [3] = 1.0;

   B[1] [0] = 1.0;
   B[1] [1] = 1.0;
   B[1] [2] = 1.0;
   B[1] [3] = 1.0;

   B[2] [0] = 1.0;
   B[2] [1] = 1.0;
   B[2] [2] = 1.0;
   B[2] [3] = 1.0;

   B[3] [0] = 1.0;
   B[3] [1] = 1.0;
   B[3] [2] = 1.0;
   B[3] [3] = 1.0;

   SET_ID_MATRIX(A);

   Matrix_4x4_Multiplication(A, B, C);

   for (i = 0; i < 4; i++) {
      printf("C [%d] [0] = %f, C [%d] [1] = %f, C [%d] [2] = %f, C [%d] [3] = %f\n", i, C[i] [0], i, C[i] [1], i, C[i] [2], i, C[i] [3]);
   }

   Vector1[I_HAT] = 0.0;
   Vector1[J_HAT] = 0.0;
   Vector1[K_HAT] = 1.0;

   A[0] [1] = -0.85;
   A[0] [2] = 0.25;

   A[1][0] = -0.75;
   A[1][2] = 0.7;

   A[2][0] = 0.5;
   A[2][1] = 1.0;

   Vector_Matrix_Multiplication(Vector1, A, Vector2);

   printf("Vector2 = (%f, %f, %f)\n", Vector2[I_HAT], Vector2[J_HAT],
          Vector2[K_HAT]);
}
#endif
